#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "util.h"

int
main(void)
{
	size_t i = 0, nf = 0, nr = 0, linesize = 0;
	char *line = NULL, *data = NULL;
	double val, *vals = NULL;

	if (pledge("stdio", NULL) == -1)
		err(2, "pledge");

	while (getline(&line, &linesize, stdin) > 0) {
		if (nr == 0)
			if ((nf = allocarr(&vals, line, linesize)) == 0)
				errx(1, "no fields in input");
		data = line;
		for (i = 0; i < nf; i++) {
			if (!scannextval(&data, &val))
				errx(1, "could not parse line %ld, field %ld", nr + 1, i + 1);
			if (nr == 0 || val > vals[i])
				vals[i] = val;
		}
		nr++;
	}
	printarr(vals, nf);

	free(line);
	free(vals);

	return 0;
}
