#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "util.h"

int
main(void)
{
	size_t i = 0, j = 0, nf = 0, nr = 0, linesize = 0;
	char *line = NULL, *data = NULL;
	double val, **vals = NULL;

	if (pledge("stdio", NULL) == -1)
		err(2, "pledge");

	vals = calloc(1, sizeof(double *));
	while (getline(&line, &linesize, stdin) > 0) {
		if (nr > 0)
			if (!(vals = xreallocarray(vals, nr + 1, sizeof(double *))))
				err(1, "reallocarray");
		if ((nf = allocarr(&vals[nr], line, linesize)) == 0)
			errx(1, "no fields in input");
		data = line;
		for (i = 0; i < nf; i++) {
			if (!scannextval(&data, &val))
				errx(1, "could not parse line %ld, field %ld", nr + 1, i + 1);
			vals[nr][i] = val;
		}
		nr++;
	}
	for (i = 0; i < nf; i++) {
		for (j = 0; j < nr; j++) {
			printf("%.17g", vals[j][i]);
			if (j < nr - 1)
				printf(DELIMSTR);
		}
		puts("");
	}

	free(line);
	for (i = 0; i < nr; i++)
		free(vals[i]);
	free(vals);

	return 0;
}
